//
//  NSURL+SocialLinks.m
//
//  Created by Jesse Squires on 12/31/12.
//  Copyright (c) 2012 Hexed Bits. All rights reserved.
//
//  The MIT License
//  Copyright (c) 2013 Jesse Squires
//
//  Permission is hereby granted, free of charge, to any person obtaining a copy of this software and
//  associated documentation files (the "Software"), to deal in the Software without restriction, including
//  without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
//  copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the
//  following conditions:
//
//  The above copyright notice and this permission notice shall be included in
//  all copies or substantial portions of the Software.
//
//  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT
//  LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
//  IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
//  IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
//  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
//

#import "NSURL+SocialLinks.h"

@implementation NSURL (SocialLinks)

+ (void)openWebsite:(NSString *)site
{
    [[UIApplication sharedApplication] openURL:[NSURL URLWithString:site]];
}

+ (void)openFacebookPage:(NSString *)pageName pageID:(NSString *)pageID
{
    NSURL *fbURL = [NSURL URLWithString:[NSString stringWithFormat:@"fb://profile/%@",pageID]];
    
    if([[UIApplication sharedApplication] openURL:fbURL])
        [[UIApplication sharedApplication] openURL:fbURL];
    else
        [[UIApplication sharedApplication] openURL:[NSURL URLWithString:[NSString stringWithFormat:@"http://facebook.com/%@",pageName]]];
}

+ (void)openFacebookUser:(NSString *)fbUser
{
    NSURL *url = [NSURL URLWithString:[NSString stringWithFormat:@"https://graph.facebook.com/%@", fbUser]];
    NSData *data = [NSData dataWithContentsOfURL:url];
    
    NSDictionary *json = (data) ? [NSJSONSerialization JSONObjectWithData:data options:kNilOptions error:nil] : nil;
    id userID = (json) ? [json objectForKey:@"id"] : nil;

    NSURL *fbURL = [NSURL URLWithString:[NSString stringWithFormat:@"fb://profile/%@",userID]];
    
    if(userID && [[UIApplication sharedApplication] openURL:fbURL])
        [[UIApplication sharedApplication] openURL:fbURL];
    else
        [[UIApplication sharedApplication] openURL:[NSURL URLWithString:[NSString stringWithFormat:@"http://facebook.com/%@",fbUser]]];
}

+ (void)openTwitterAccount:(NSString *)twAccount
{
    NSURL *twURL = [NSURL URLWithString:[NSString stringWithFormat:@"twitter://user?screen_name=%@",twAccount]];
    
    if([[UIApplication sharedApplication] canOpenURL:twURL])
        [[UIApplication sharedApplication] openURL:twURL];
    else
        [[UIApplication sharedApplication] openURL:[NSURL URLWithString:[NSString stringWithFormat:@"http://twitter.com/%@",twAccount]]];
}

+ (void)openRateReviewForAppID:(NSString *)appID
{
    NSString *rateURL = [NSString stringWithFormat:@"itms-appss://itunes.apple.com/WebObjects/MZStore.woa/wa/viewContentsUserReviews?id=%@&pageNumber=0&sortOrdering=1&type=Purple+Software&mt=8", appID];
    [[UIApplication sharedApplication] openURL:[NSURL URLWithString:rateURL]];
}

+ (void)openGiftThisAppForAppID:(NSString *)appID
{
    NSString* giftURL = [NSString stringWithFormat:@"itms-appss://buy.itunes.apple.com/WebObjects/MZFinance.woa/wa/giftSongsWizard?gift=1&salableAdamId=%@&productType=C&pricingParameter=STDQ&mt=8&ign-mscache=1", appID];
    
    [[UIApplication sharedApplication] openURL:[NSURL URLWithString:giftURL]];
}

@end